11/02/2013 04:43 PM - Zbigniew Rebacz

Status: Rejected Start date: 11/02/2013

Priority: Normal Due date:

Assignee: Zbigniew Rebacz % Done: 100%

Category: CtrlLib Estimated time: 0.00 hour

Target version: Spent time: 0.00 hour

Description

Personally, I think it would be usful if user will be able to mark whole paragraph fast in RichTextView. Below is the implementation of

"LeftTriple" method:

void RichTextView::LeftTriple(Point p, dword keyflags)

{

    const int pos = GetPointPos(p);

    const int paralen = text.GetRichPos(pos).paralen;

    int len = 0;

    cursor = pos;

    while(cursor + 1 < text.GetLength() && text[cursor] != '\n') {

        cursor++;

        len++;

    }

    anchor = pos;

    while(anchor > 0 && len != paralen) {

        anchor--;

        len++;

    }

    RefreshSel();

    SetFocus();

}

I enclose tow improved source files.

History

#1 - 11/02/2013 08:32 PM - Zbigniew Rebacz

- File deleted (RichTextView.cpp)

#2 - 11/02/2013 08:33 PM - Zbigniew Rebacz

- File RichTextView.cpp added

#3 - 11/06/2013 09:47 AM - Miroslav Fidler

Implemented, however I have used more straighforward code (copied from RichEdit...)

#4 - 11/06/2013 04:11 PM - Zbigniew Rebacz

- File deleted (RichText.h)

#5 - 11/06/2013 04:11 PM - Zbigniew Rebacz
- File deleted (RichTextView.cpp)

#6 - 11/06/2013 04:18 PM - Zbigniew Rebacz

- File RichTextView.cpp added

Hello Mirek,

In my opinion we shouldn't add one to cursor, because it contributes to selecting empty space.The code should look like this:

void RichTextView::LeftTriple(Point p, dword keyflags)

{

    int pos = GetPointPos(p);

    RichPos rp = text.GetRichPos(pos);

    anchor = pos - rp.posinpara;

    cursor = anchor + rp.paralen;

    RefreshSel();

    SetFocus();

}

#7 - 11/06/2013 04:18 PM - Zbigniew Rebacz

- Assignee changed from Zbigniew Rebacz to Miroslav Fidler

#8 - 11/06/2013 04:48 PM - Zbigniew Rebacz

I would like to recommend this little change also for RichTextEditor.

#9 - 11/06/2013 06:09 PM - Zbigniew Rebacz

Although, previous solution can be more useful for RichTextEditor (I am not sure about this). I am certain sure, that marking text without empty area is more

natural for RichTextView.

At the end, I would like to tell that I understand that you don't want the differences between RichTextView and RichTextEdit in behaviour. However, keep in

mind that what is useful for viewing document is not necessarily good for editing document. Ultimate++ as a complex library should take into account such

nuances.

#10 - 11/07/2013 09:26 PM - Zbigniew Rebacz

I have made some research on Windows (Windows 8) and it seems that my solution is 100% compatibility with M$ (This behavior can be seen in M$ help

windows).

#11 - 11/10/2013 11:29 PM - Zbigniew Rebacz

Implementation for RichEdit (RichEdit/Mouse.cpp - line 349):

void RichEdit::LeftTriple(Point p, dword flags)

{
    NextUndo();

    int c = GetMousePos(p);

    if(c >= 0 && c != objectpos) {

        RichPos rp = text.GetRichPos(c);

        Select(c - rp.posinpara, rp.paralen);

    }

}

#12 - 11/10/2013 11:30 PM - Zbigniew Rebacz

- File deleted (RichTextView.cpp)

#13 - 11/11/2013 02:12 PM - Miroslav Fidler

- Status changed from Ready for QA to Rejected

- Assignee changed from Miroslav Fidler to Zbigniew Rebacz

Zbigniew Rebacz wrote:

Hello Mirek,

In my opinion we shouldn't add one to cursor, because it contributes to selecting empty space.The code should look like this:

Well, it is interesting. IMO closest equivalent to RichTextView in this regard is web browser. Here:

Internet Explorer and Chrome seem to select WITH the terminal "paragraph ending character".

Firefox seems to select WITHOUT.

So it is quite obviously a matter of opinion. IMO, it is better to include it.

Mirek
